Index: main/plugin-link-directory/pages/services/directory/utils/thumbnails_utils.xsl
===================================================================
--- main/plugin-link-directory/pages/services/directory/utils/thumbnails_utils.xsl	(revision 0)
+++ main/plugin-link-directory/pages/services/directory/utils/thumbnails_utils.xsl	(revision 0)
@@ -0,0 +1,245 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!--
+   Copyright 2015 Anyware Services
+
+   Licensed under the Apache License, Version 2.0 (the "License");
+   you may not use this file except in compliance with the License.
+   You may obtain a copy of the License at
+
+       http://www.apache.org/licenses/LICENSE-2.0
+
+   Unless required by applicable law or agreed to in writing, software
+   distributed under the License is distributed on an "AS IS" BASIS,
+   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+   See the License for the specific language governing permissions and
+   limitations under the License.
+   -->
+<xsl:stylesheet version="1.0" 
+                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
+                xmlns:ametys="org.ametys.web.transformation.xslt.AmetysXSLTHelper"
+                xmlns:resolver="org.ametys.cms.transformation.xslt.ResolveURIComponent"
+                xmlns:exsl="http://exslt.org/common"
+                xmlns:i18n="http://apache.org/cocoon/i18n/2.1">
+    
+    <!--  The links in thumbnails mode -->
+    <xsl:template name="links-thumbnails">
+        <xsl:param name="links"/>
+        <xsl:param name="moreThreshold"/>
+        <xsl:param name="height" select="96"/>
+        <xsl:param name="width" select="96"/>
+        <xsl:param name="showThemes"/>
+        <xsl:param name="showUrl"/>
+        
+        <!-- Display an error if the selected themes are invalid -->
+        <xsl:call-template name="wrong-or-deleted-themes"/>
+
+        <xsl:variable name="links-raw">
+            <xsl:call-template name="separate-links">
+                <xsl:with-param name="links" select="$links"/>
+                <xsl:with-param name="moreThreshold" select="$moreThreshold"/>
+            </xsl:call-template>
+        </xsl:variable>
+        
+        <xsl:variable name="separated-links" select="exsl:node-set($links-raw)"/>
+        
+        <!-- The first $moreThreshold links -->
+        <ul class="links">
+            <xsl:apply-templates select="$separated-links/primary/link" mode="thumbnails">
+                <xsl:with-param name="height" select="$height"/>
+                <xsl:with-param name="width" select="$width"/>
+                <xsl:with-param name="showThemes" select="$showThemes"/>
+                <xsl:with-param name="showUrl" select="$showUrl"/>
+            </xsl:apply-templates>     
+            
+            <xsl:if test="count($links) &gt; $moreThreshold">
+                <xsl:call-template name="see-more-less">
+                    <xsl:with-param name="height" select="$height"/>
+                    <xsl:with-param name="width" select="$width"/>
+                    <xsl:with-param name="buttonId" select="$uniqueId"/>
+                </xsl:call-template>
+            </xsl:if>
+        </ul>
+            
+        <!-- The remaining links -->
+        <xsl:if test="$separated-links/secondary">
+            <ul class="links" id="secondary-links-{$uniqueId}">
+	            <xsl:apply-templates select="$separated-links/secondary/link" mode="thumbnails">
+	               <xsl:with-param name="height" select="$height"/>
+                   <xsl:with-param name="width" select="$width"/>
+                   <xsl:with-param name="showThemes" select="$showThemes"/>
+                   <xsl:with-param name="showUrl" select="$showUrl"/>
+                </xsl:apply-templates>
+            </ul>
+            <script type="text/javascript">
+                $j("#secondary-links-<xsl:value-of select="$uniqueId"/>").hide();
+            </script>      
+        </xsl:if>
+    </xsl:template>
+    
+    <!-- Separate the links in two groups for input data and service in thumbnails view -->
+    <xsl:template name="separate-links">
+        <xsl:param name="links"/>
+        <xsl:param name="moreThreshold"/>
+        
+        <primary>
+            <xsl:for-each select="$links">
+                <xsl:sort select="@user-selected = 'true'" order="descending"/>
+                
+                <xsl:if test="position() &lt; $moreThreshold or (count($links) = 8 and position() = $moreThreshold)">
+                    <xsl:copy-of select="."/>
+                </xsl:if>
+            </xsl:for-each>
+        </primary>
+        <secondary>
+            <xsl:for-each select="$links">
+                <xsl:sort select="@user-selected = 'true'" order="descending"/>
+                
+                <xsl:choose>
+                    <xsl:when test="position() &gt;= $moreThreshold">
+                        <xsl:copy-of select="."/>
+                    </xsl:when>
+                </xsl:choose>
+            </xsl:for-each>
+        </secondary>
+    </xsl:template>
+    
+    <xsl:template match="link" mode="thumbnails">
+        <xsl:param name="height"/>
+        <xsl:param name="width"/>
+        <xsl:param name="showThemes"/>
+        <xsl:param name="showUrl"/>
+        
+        <li>
+            <xsl:attribute name="class">link <xsl:call-template name="common-utils-class"/></xsl:attribute>
+            
+            <a href="{@url}" onclick="window.open(this.href); return false;">
+                 <xsl:call-template name="link-title">
+                    <xsl:with-param name="showThemes" select="$showThemes"/>
+                    <xsl:with-param name="showUrl" select="$showUrl"/>
+                 </xsl:call-template>
+                 <xsl:call-template name="link-picture">
+                    <xsl:with-param name="height" select="$height"/>
+                    <xsl:with-param name="width" select="$width"/>
+                 </xsl:call-template>
+                 <xsl:call-template name="link-text"/>
+            </a>
+        </li>
+    </xsl:template>
+    
+    <xsl:template name="link-title">
+        <xsl:param name="showThemes"/>
+        <xsl:param name="showUrl"/>
+        
+        <xsl:attribute name="title">
+           <xsl:choose>
+               <xsl:when test="normalize-space(@alternative) != ''">
+                   <xsl:value-of select="@alternative"/>
+               </xsl:when>
+               <xsl:otherwise>
+                   <xsl:value-of select="@url"/>
+               </xsl:otherwise>
+           </xsl:choose>
+           <xsl:if test="$showThemes = 'true'">
+                <xsl:for-each select="themes/theme">
+                    <xsl:if test="position() = 1">
+                         <xsl:text> - </xsl:text>
+                    </xsl:if>
+                    <xsl:value-of select="@label"/>
+                    <xsl:if test="position() != last()">
+                         <xsl:text>, </xsl:text>
+                    </xsl:if>
+                </xsl:for-each>
+           </xsl:if>
+           <xsl:if test="$showUrl = 'true'">
+               <xsl:text> (</xsl:text><xsl:value-of select="@url"/><xsl:text>)</xsl:text>
+           </xsl:if>
+        </xsl:attribute>
+    </xsl:template>
+    
+    <xsl:template name="link-picture">
+        <xsl:param name="height"/>
+        <xsl:param name="width"/>
+        
+        <xsl:if test="@pictureType != ''">
+            <xsl:variable name="id">
+                <xsl:choose>
+                    <xsl:when test="@pictureType = 'resource'">
+                        <xsl:value-of select="@pictureId"/>
+                    </xsl:when>
+                    <xsl:when test="@pictureType = 'external'">
+                        <xsl:value-of select="concat(@picturePath, '?objectId=', @id)"/>
+                    </xsl:when>
+                </xsl:choose>
+            </xsl:variable>
+            
+            <span class="picture">
+                <img src="{resolver:resolveBoundedImage(@imageType, $id, $height, $width)}" alt="{@pictureAlternative}"/>
+            </span>
+         </xsl:if>
+    </xsl:template>
+                
+    <xsl:template name="link-text">
+        <span>
+            <xsl:attribute name="class">text <xsl:if test="@pictureType = ''">nopicture</xsl:if></xsl:attribute>
+        
+             <xsl:choose>
+                 <xsl:when test="@title != ''"> 
+                        <xsl:value-of select="@title"/>
+                 </xsl:when>
+                 <xsl:otherwise>
+                        <xsl:value-of select="@url"/>
+                 </xsl:otherwise>
+             </xsl:choose>
+        </span>
+    </xsl:template>
+    
+    <!-- The see more/less links functionality -->
+    <xsl:template name="see-more-less">
+        <xsl:param name="height"/>
+        <xsl:param name="width"/>
+        <xsl:param name="buttonId"/>
+        
+        <script type="text/javascript">
+            
+            document.write("&lt;li id=\"show-more-links-<xsl:value-of select="$buttonId"/>\" class=\"link\" &gt;&lt;a href=\"javascript:showSecondaryLinks<xsl:value-of select="$buttonId"/>()\" title=\"<i18n:text i18n:key="PLUGINS_LINKDIRECTORY_SEE_MORE" i18n:catalogue="plugin.link-directory"/>\"&gt;");
+            <xsl:call-template name="show-more-picture">
+                <xsl:with-param name="height" select="$height"/>
+                <xsl:with-param name="width" select="$width"/>
+            </xsl:call-template>
+            document.write("&lt;/a&gt;&lt;/li&gt;");
+            
+            document.write("&lt;li id=\"show-less-links-<xsl:value-of select="$buttonId"/>\" class=\"link\" &gt;&lt;a href=\"javascript:hideSecondaryLinks<xsl:value-of select="$buttonId"/>()\" title=\"<i18n:text i18n:key="PLUGINS_LINKDIRECTORY_SEE_LESS" i18n:catalogue="plugin.link-directory"/>\"&gt;");
+            <xsl:call-template name="show-less-picture">
+                <xsl:with-param name="height" select="$height"/>
+                <xsl:with-param name="width" select="$width"/>
+            </xsl:call-template>
+            document.write("&lt;/a&gt;&lt;/li&gt;");
+            
+            function showSecondaryLinks<xsl:value-of select="$buttonId"/>()
+            {
+                $j("#show-more-links-<xsl:value-of select="$buttonId"/>").hide();
+                $j("#show-less-links-<xsl:value-of select="$buttonId"/>").show();
+                $j("#secondary-links-<xsl:value-of select="$buttonId"/>").show();
+            }
+            
+            function hideSecondaryLinks<xsl:value-of select="$buttonId"/>()
+            {
+                $j("#show-more-links-<xsl:value-of select="$buttonId"/>").show();
+                $j("#show-less-links-<xsl:value-of select="$buttonId"/>").hide();
+                $j("#secondary-links-<xsl:value-of select="$buttonId"/>").hide();
+            }
+    
+            $j("#show-less-links-<xsl:value-of select="$buttonId"/>").hide();
+        </script>
+    </xsl:template>
+   
+    <xsl:template name="show-less-picture">
+        document.write("&lt;span class=\"picture\"&gt;<i18n:text i18n:key="PLUGINS_LINKDIRECTORY_LESS" i18n:catalogue="plugin.link-directory"/>&lt;/span&gt;");
+    </xsl:template>
+   
+    <xsl:template name="show-more-picture">
+        document.write("&lt;span class=\"picture\"&gt;<i18n:text i18n:key="PLUGINS_LINKDIRECTORY_MORE" i18n:catalogue="plugin.link-directory"/>&lt;/span&gt;");
+    </xsl:template>
+    
+</xsl:stylesheet>
+    
\ No newline at end of file
Index: main/plugin-link-directory/resources/js/org/ametys/linkdirectory/LinkDirectoryActions.i18n.js
===================================================================
--- main/plugin-link-directory/resources/js/org/ametys/linkdirectory/LinkDirectoryActions.i18n.js	(revision 28682)
+++ main/plugin-link-directory/resources/js/org/ametys/linkdirectory/LinkDirectoryActions.i18n.js	(working copy)
@@ -1,5 +1,5 @@
 /*
- *  Copyright 2012 Anyware Services
+ *  Copyright 2015 Anyware Services
  *
  *  Licensed under the Apache License, Version 2.0 (the "License");
  *  you may not use this file except in compliance with the License.
@@ -16,6 +16,7 @@
 
 Ext.namespace('org.ametys.linkdirectory.Edit');
 Ext.namespace('org.ametys.linkdirectory.Delete');
+Ext.namespace('org.ametys.linkdirectory.Move');
 
 /**
  * @private
@@ -107,6 +108,8 @@
         var params = form.getValues();
         params.siteName = context.parameters.siteName;
         params.language = org.ametys.linkdirectory.Edit.linkLang;
+        // do 'grant-any-user' mannually since it is a checkbox, not correctly return by form.getValues()
+        params['grant-any-user'] = form.findField('grant-any-user').getValue();
         
         org.ametys.linkdirectory.Edit.dialog.showWaitMsg();
         
@@ -294,3 +297,41 @@
     var event = org.ametys.messagebus.bus.MessageBuilder.getInstance().createMessage(org.ametys.ribbon.RibbonManager.EVENTTYPE_DELETED, null, args[0]);
     org.ametys.messagebus.MessageBus.getInstance().fireMessages([event]);
 }
+
+/**
+ * Move link 
+ */
+org.ametys.linkdirectory.Move.act = function(id, config, pluginName)
+{
+    var targets = org.ametys.ribbon.RibbonManager.getInstance().getCurrentSelectionTargets();
+    var allTargets = org.ametys.messagebus.message.MessageTargetHelper.findAll(targets, function(target) { return target.getType() == 'link-directory' });
+    
+    if (allTargets.length != 1)
+    {
+        return;
+    }
+    
+    var id = allTargets[0].getParameters().id;
+    
+    var params = {
+        'id': id,
+        'siteName': context.parameters.siteName,
+        'role': config.role
+    };
+    
+    var serverMessage = new org.ametys.servercomm.ServerMessage(pluginName, '/link/move', params, org.ametys.servercomm.ServerComm.PRIORITY_MAJOR, org.ametys.linkdirectory.Move.callback, this, [id]);
+    org.ametys.servercomm.ServerComm.getInstance().send(serverMessage);
+}
+
+org.ametys.linkdirectory.Move.callback = function(response, args)
+{
+    if (org.ametys.servercomm.ServerComm.handleBadResponse("<i18n:text i18n:key='PLUGINS_LINKDIRECTORY_HANDLE_MOVE_LINK_ERROR'/>", response, 'org.ametys.linkdirectory.Move'))
+    {
+        return;
+    }
+    
+    var id = args[0];
+    var target = org.ametys.messagebus.bus.MessageBuilder.getInstance().createTarget('link-directory', {'id': id});
+    var event = org.ametys.messagebus.bus.MessageBuilder.getInstance().createMessage(org.ametys.ribbon.RibbonManager.EVENTTYPE_MOVED, null, [target]);
+    org.ametys.messagebus.MessageBus.getInstance().fireMessages([event]);
+}
Index: main/plugin-link-directory/resources/js/org/ametys/linkdirectory/LinkDirectoryDialog.i18n.js
===================================================================
--- main/plugin-link-directory/resources/js/org/ametys/linkdirectory/LinkDirectoryDialog.i18n.js	(revision 28682)
+++ main/plugin-link-directory/resources/js/org/ametys/linkdirectory/LinkDirectoryDialog.i18n.js	(working copy)
@@ -31,7 +31,7 @@
         icon: getPluginResourcesUrl(pluginName) + '/img/link-directory-16.png',
         
         width: 500,
-        height: 460,
+        height: 590, 
         autoScroll: false,
         
         items: [this._formPanel],
@@ -58,6 +58,8 @@
 
 org.ametys.linkdirectory.LinkDirectoryDialog.prototype._createFormPanel = function()
 {
+	var me = this;
+	
     var formPanel = new Ext.form.FormPanel( {
         labelWidth: 125,
         defaultType: 'textfield',
@@ -92,7 +94,8 @@
                 name: 'picture',
                 fieldLabel: "<i18n:text i18n:key='PLUGINS_LINKDIRECTORY_LINK_DIALOG_PICTURE_LABEL'/>",
                 desc: "<i18n:text i18n:key='PLUGINS_LINKDIRECTORY_LINK_DIALOG_PICTURE_DESC'/>",
-                width: 280
+                width: 280,
+                labelStyle: "height: 100px;"
             }),
             new org.ametys.form.TextField({
                 name: 'picture-alternative',
@@ -104,7 +107,7 @@
                 name: 'themes',
                 fieldLabel: "<i18n:text i18n:key='PLUGINS_LINKDIRECTORY_LINK_DIALOG_THEMES_LABEL'/>",
                 desc: "<i18n:text i18n:key='PLUGINS_LINKDIRECTORY_LINK_DIALOG_THEMES_DESC'/>",
-                width: 280,
+                width: 283,
                 modifiable: true
             }),
             new org.ametys.form.TextAreaField({
@@ -114,6 +117,33 @@
                 width: 280,
                 height: 90
             }),
+            new org.ametys.form.BooleanField({
+                name: 'grant-any-user',
+                fieldLabel: "<i18n:text i18n:key='PLUGINS_LINKDIRECTORY_LINK_DIALOG_GRANT_ANY_USER_LABEL'/>",
+                desc: "<i18n:text i18n:key='PLUGINS_LINKDIRECTORY_LINK_DIALOG_GRANT_ANY_USER_DESC'/>",
+                width: 280,
+                listeners: {'check': function(field, checked) {
+                						me._formPanel.getForm().findField('fousers').setDisabled(checked);
+                						me._formPanel.getForm().findField('fogroups').setDisabled(checked);
+                					}
+                			}
+            }),
+            new org.ametys.web.widgets.FOUserSelectorWidget({
+                name: 'fousers',
+                fieldLabel: "<i18n:text i18n:key='PLUGINS_LINKDIRECTORY_LINK_DIALOG_GRANTED_USERS_LABEL'/>",
+                desc: "<i18n:text i18n:key='PLUGINS_LINKDIRECTORY_LINK_DIALOG_GRANTED_USERS_DESC'/>",
+                width: 280,
+                multiple: true,
+                modifiable: true
+            }),
+            new org.ametys.web.widgets.FOGroupSelectorWidget({
+                name: 'fogroups',
+                fieldLabel: "<i18n:text i18n:key='PLUGINS_LINKDIRECTORY_LINK_DIALOG_GRANTED_GROUPS_LABEL'/>",
+                desc: "<i18n:text i18n:key='PLUGINS_LINKDIRECTORY_LINK_DIALOG_GRANTED_GROUPS_DESC'/>",
+                width: 280,
+                multiple: true,
+                modifiable: true,
+            })
         ],
         
         bodyStyle: 'padding:10px',
@@ -148,10 +178,15 @@
         }
     }, this);
     
+    // Reset the dialog's fields
     form.findField('themes').setThemeValue('');
     form.findField('id').setValue(id);
     
-    if (id != null &amp;&amp; id != '')
+    form.findField('fousers').setUserValue('');
+    form.findField('fogroups').setGroupValue('');
+    form.findField('grant-any-user').setValue(false);
+    
+    if (id)
     {
         var serverMessage = new org.ametys.servercomm.ServerMessage(this._pluginName, 'link.xml', {'id': id}, org.ametys.servercomm.ServerComm.PRIORITY_MAJOR, this._initCb, this, {form: form});
         var response = org.ametys.servercomm.ServerComm.getInstance().send(serverMessage);
@@ -219,7 +254,32 @@
         ids.push(themeNodes[i].getAttribute('id'));
         labels.push(themeNodes[i].getAttribute('label'));
     }
+    
     form.findField('themes').setThemeValue(ids, labels);
     
     form.findField('content').setValue(content);
+    
+    // Update access limitations
+    var grantAnyUser = linkNode.getAttribute('grantAnyUser') || false;
+    form.findField('grant-any-user').setValue(grantAnyUser);
+    
+    var grantedUserNodes = linkNode.selectNodes('granted-users/granted-user');
+    var logins = [];
+    var fullNames = [];
+    for (var i = 0; i &lt; grantedUserNodes.length; i++)
+	{
+    	logins.push(grantedUserNodes[i].getAttribute('login'));
+    	fullNames.push(grantedUserNodes[i].getAttribute('fullName'));
+	}
+    form.findField('fousers').setUserValue(logins, fullNames);
+    
+    var grantedGroupNodes = linkNode.selectNodes('granted-groups/granted-group');
+    var ids = [];
+    var labels = [];
+    for (var i = 0; i &lt; grantedGroupNodes.length; i++)
+	{
+    	ids.push(grantedUserNodes[i].getAttribute('id'));
+    	labels.push(grantedUserNodes[i].getAttribute('label'));
+	}
+    form.findField('fogroups').setGroupValue(ids, labels);
 }
Index: main/plugin-link-directory/resources/js/org/ametys/linkdirectory/LinkDirectoryMessageTargetFactory.i18n.js
===================================================================
--- main/plugin-link-directory/resources/js/org/ametys/linkdirectory/LinkDirectoryMessageTargetFactory.i18n.js	(revision 28682)
+++ main/plugin-link-directory/resources/js/org/ametys/linkdirectory/LinkDirectoryMessageTargetFactory.i18n.js	(working copy)
@@ -53,6 +53,7 @@
    parameters['url'] = link.getAttribute("url"); 
    parameters['title'] = link.getAttribute("title"); 
    parameters['alternative'] = link.getAttribute("alternative"); 
+   parameters['limitedAccess'] = link.getAttribute("limitedAccess"); 
    parameters['themes'] = link.selectSingleNode("themes")[org.ametys.servercomm.ServerComm.xmlTextContent]; 
 	   
    return target;
Index: main/plugin-link-directory/resources/js/org/ametys/linkdirectory/LinkDirectoryTool.i18n.js
===================================================================
--- main/plugin-link-directory/resources/js/org/ametys/linkdirectory/LinkDirectoryTool.i18n.js	(revision 28682)
+++ main/plugin-link-directory/resources/js/org/ametys/linkdirectory/LinkDirectoryTool.i18n.js	(working copy)
@@ -1,5 +1,5 @@
 /*
- *  Copyright 2012 Anyware Services
+ *  Copyright 2015 Anyware Services
  *
  *  Licensed under the Apache License, Version 2.0 (the "License");
  *  you may not use this file except in compliance with the License.
@@ -23,6 +23,10 @@
 
 Ext.extend(org.ametys.linkdirectory.LinkDirectoryTool, org.ametys.uitool.tool.Tool, {});
 
+/**
+ * List of links predecessors and successors, indexed by link ID.
+ * @private
+ */
 org.ametys.linkdirectory.LinkDirectoryTool.prototype.createPanel = function()
 {
     // The mapping for XML doc
@@ -31,7 +35,8 @@
         {name: 'url', mapping: '@url'},
         {name: 'title', mapping: '@title'},
         {name: 'alternative', mapping: '@alternative'},
-        {name: 'themes', mapping: 'themes'}
+        {name: 'themes', mapping: 'themes'},
+        {name: 'limitedAccess', mapping: '@limitedAccess'}
     ]);
     
     // HTTP proxy
@@ -51,8 +56,6 @@
             },
             mapping
         ),
-        
-        sortInfo: {field: 'title', direction: 'ASC'}
     });
     
     this._xmlStore.on('beforeload', this._onBeforeLoad, this);
@@ -82,14 +85,18 @@
         store: this._xmlStore,
         
         view: new Ext.grid.GridView({
-            forceFit: true
+        	forceFit: true,
+	        enableGroupingMenu : false,
+	        showGroupName: false,
+	    	hideGroupedColumn: true
         }),
         
         columns: [
-            {header: "<i18n:text i18n:key='PLUGINS_LINKDIRECTORY_UITOOL_URL'/>", width: 160, sortable: true, dataIndex: 'url'},
-            {header: "<i18n:text i18n:key='PLUGINS_LINKDIRECTORY_UITOOL_TITLE'/>", width: 100, sortable: true, dataIndex: 'title'},
-            {header: "<i18n:text i18n:key='PLUGINS_LINKDIRECTORY_UITOOL_ALTERNATIVE'/>", width: 100, sortable: true, dataIndex: 'alternative'},
-            {header: "<i18n:text i18n:key='PLUGINS_LINKDIRECTORY_UITOOL_THEMES'/>", width: 100, sortable: true, dataIndex: 'themes'}
+            {header: "<i18n:text i18n:key='PLUGINS_LINKDIRECTORY_UITOOL_URL'/>", width: 160, dataIndex: 'url'},
+            {header: "<i18n:text i18n:key='PLUGINS_LINKDIRECTORY_UITOOL_TITLE'/>", width: 100, dataIndex: 'title'},
+            {header: "<i18n:text i18n:key='PLUGINS_LINKDIRECTORY_UITOOL_ALTERNATIVE'/>", width: 100, dataIndex: 'alternative'},
+            {header: "<i18n:text i18n:key='PLUGINS_LINKDIRECTORY_UITOOL_THEMES'/>", width: 100, dataIndex: 'themes'},
+            {header: "<i18n:text i18n:key='PLUGINS_LINKDIRECTORY_UITOOL_LIMITED_ACCESS'/>", width: 25, dataIndex: 'limitedAccess'}
         ]
     });
     this._grid.getSelectionModel().on('selectionchange', this._onSelectLink, this);
@@ -137,13 +144,20 @@
 org.ametys.linkdirectory.LinkDirectoryTool.prototype._sendSelectionMessage = function(records)
 {
     var targets = [];
-    for (var i=0; i &lt; records.length; i++)
+    for (var i = 0; i &lt; records.length; i++)
     {
-        targets.push(org.ametys.messagebus.bus.MessageBuilder.getInstance().createTarget('link-directory', {'id': records[i].data.id}));
+    	var parameters = {},
+    	link = records[i];
+    	
+    	parameters.id = link.data.id;
+    	parameters.index = link.store.indexOf(link);
+    	parameters.size = link.store.totalLength;
+    	
+        targets.push(org.ametys.messagebus.bus.MessageBuilder.getInstance().createTarget('link-directory', parameters));
     }
-    
+	
     var event = org.ametys.messagebus.bus.MessageBuilder.getInstance().createMessage(org.ametys.ribbon.RibbonManager.EVENTTYPE_SELECTIONCHANGED, null, targets);
-    org.ametys.messagebus.MessageBus.getInstance().fireMessages([event]);
+	org.ametys.messagebus.MessageBus.getInstance().fireMessages([event]);
 }
 
 org.ametys.linkdirectory.LinkDirectoryTool.prototype.onMessage = function(messages)
@@ -180,6 +194,10 @@
                 this._removeLink(id);
             } 
         }
+		else if (messages[i].getType().getName() == org.ametys.ribbon.RibbonManager.EVENTTYPE_MOVED)
+		{
+		    this.refresh();
+		}
     }
 }
 
@@ -202,8 +220,11 @@
         record.set('title', params.title);
         record.set('alternative', params.alternative);
         record.set('themes', params.themes);
+        record.set('limitedAccess', params.limitedAccess);
         record.commit();
     }
+    
+    this._updateSelections();
 }
 
 /**
@@ -219,11 +240,14 @@
         'url': params.url,
         'title': params.title,
 		'alternative': params.alternative,
-		'themes': params.themes
+		'themes': params.themes,
+		'limitedAccess': params.limitedAccess
     }, params.id);
     
     this._grid.getStore().addSorted(record);
     this._grid.getSelectionModel().selectRecords([record]);
+
+    this._updateSelections();
 }
 
 
@@ -383,6 +407,7 @@
 org.ametys.linkdirectory.LinkDirectoryTool.prototype._onLoad = function(store, records, options)
 {
     this.upToDate();
+    this._updateSelections();
 }
 
 /**
@@ -392,12 +417,7 @@
 org.ametys.linkdirectory.LinkDirectoryTool.prototype._onFocus = function(messages)
 {
     this._hasFocus = true;
-    
-    var records = this._grid.getSelectionModel().getSelections();
-    if (records.length &gt; 0)
-    {
-        this._sendSelectionMessage(records);
-    }
+    this._updateSelections();
 }
 
 /**
@@ -422,3 +442,16 @@
 		eventBus.fireMessages([event]);
 	}
 }
+
+/**
+ * @private
+ * Update the selections
+ */
+org.ametys.linkdirectory.LinkDirectoryTool.prototype._updateSelections = function ()
+{
+	var records = this._grid.getSelectionModel().getSelections();
+	if (records.length &gt; 0)
+	{
+	    this._sendSelectionMessage(records);
+	}
+}
